#pragma once
#include "arc_interface.h"

//---UNICODEpArchiverDLL`
typedef struct {
	DWORD 			dwOriginalSize;		/* t@C̃TCY */
 	DWORD 			dwCompressedSize;	/* k̃TCY */
	DWORD			dwCRC;				/* i[t@C̃`FbNT */
	UINT			uFlag;				/*  */
										/* Status flag */
	UINT			uOSType;			/* ɍ쐬Ɏgꂽ OS */
	WORD			wRatio;				/* k */
	WORD			wDate;				/* i[t@C̓t(DOS `) */
	WORD 			wTime;				/* i[t@C̎(V) */
	WCHAR			szFileName[FNAME_MAX32 + 1];	/* i[t@C */
	WCHAR			dummy1[3];
	WCHAR			szAttribute[8];		/* i[t@C̑(ɌŗL) */
	WCHAR			szMode[8];			/* i[t@C̊i[[h(V) */
}	INDIVIDUALINFOW, *LPINDIVIDUALINFOW;


typedef int   (WINAPI *COMMON_ARCHIVER_HANDLERW)(const HWND,LPCWSTR,LPWSTR,const DWORD);
typedef BOOL  (WINAPI *COMMON_ARCHIVER_CHECKARCHIVEW)(LPCWSTR,const int);
typedef int	  (WINAPI *COMMON_ARCHIVER_GETFILENAMEW)(HARC,LPCWSTR,int);
typedef HARC  (WINAPI *COMMON_ARCHIVER_OPENARCHIVEW)(const HWND,LPCWSTR,const DWORD);
typedef int   (WINAPI *COMMON_ARCHIVER_FINDFIRSTW)(HARC,LPCWSTR,LPINDIVIDUALINFOW);
typedef int   (WINAPI *COMMON_ARCHIVER_FINDNEXTW)(HARC,LPINDIVIDUALINFOW);
typedef int	  (WINAPI *COMMON_ARCHIVER_GETFILECOUNTW)(LPCWSTR);
typedef int   (WINAPI *COMMON_ARCHIVER_GETMETHODW)(HARC,LPWSTR,const int);


enum LZH_COMPRESS_TYPE{
	LZH_COMPRESS_LH5,
	LZH_COMPRESS_LH0,
	LZH_COMPRESS_LH1,
	LZH_COMPRESS_LH6,
	LZH_COMPRESS_LH7,

	ENUM_COUNT_AND_LASTITEM(LZH_COMPRESS_TYPE),
};

struct CConfigLZH;
class CArchiverUNLHA:public CArchiverDLL{
protected:
	INDIVIDUALINFOW m_IndividualInfoW;

	COMMON_ARCHIVER_HANDLERW		ArchiveHandlerW;
	COMMON_ARCHIVER_CHECKARCHIVEW	ArchiverCheckArchiveW;
	COMMON_ARCHIVER_GETFILENAMEW	ArchiverGetFileNameW;
	COMMON_ARCHIVER_OPENARCHIVEW	ArchiverOpenArchiveW;
	COMMON_ARCHIVER_FINDFIRSTW		ArchiverFindFirstW;
	COMMON_ARCHIVER_FINDNEXTW		ArchiverFindNextW;
	COMMON_ARCHIVER_GETFILECOUNTW	ArchiverGetFileCountW;
	COMMON_ARCHIVER_GETMETHODW		ArchiverGetMethodW;

	void WriteResponceFile(HANDLE,LPCTSTR);
	void FormatCompressCommand(const CConfigLZH& Config,LPCTSTR lpszMethod,CString &Param);
public:
	CArchiverUNLHA();
	virtual ~CArchiverUNLHA();
	virtual bool Compress(LPCTSTR,std::list<CString>&,CConfigManager&,const PARAMETER_TYPE,int,LPCTSTR,LPCTSTR,LPCTSTR,CString &);
	virtual bool Extract(LPCTSTR,CConfigManager&,const CConfigExtract&,bool,LPCTSTR,CString &);
	virtual bool ExtractSpecifiedOnly(LPCTSTR ArcFileName,CConfigManager&,LPCTSTR OutputDir,std::list<CString>&,CString &,bool bUsePath=false);
	virtual bool ExamineArchive(LPCTSTR,CConfigManager&,bool,bool&,bool&,CString&,CString &strErr);

	//A[JCut@C폜
	virtual bool DeleteItemFromArchive(LPCTSTR ArcFileName,CConfigManager&,const std::list<CString>&,CString &strLog);
	virtual bool QueryDeleteItemFromArchiveSupported()const{return true;}		//DeleteFileT|[gĂ邩ǂ

	virtual ARCRESULT TestArchive(LPCTSTR,CString &);	//A[JCuǂ`FbN

	//A[JCuɎw肵t@Cǉ
	virtual bool AddItemToArchive(LPCTSTR ArcFileName,const std::list<CString>&,CConfigManager&,LPCTSTR lpDestDir,CString&);
	virtual bool QueryAddItemToArchiveSupported()const{return true;}


	//---UNICODE
	virtual LOAD_RESULT LoadDLL(CConfigManager&,CString &strErr);
	virtual void FreeDLL();
	virtual bool IsUnicodeCapable()const{return true;}	//UNICODEΉDLLȂtrueԂ
	virtual BOOL CheckArchive(LPCTSTR);
	virtual int GetFileCount(LPCTSTR);	//A[JCũt@CԂ

	virtual bool InspectArchiveBegin(LPCTSTR,CConfigManager&);				//ɓJn
	//virtual bool InspectArchiveEnd();						//ɓI
	virtual bool InspectArchiveGetFileName(CString&);		//ɓt@C擾
	virtual bool InspectArchiveNext();						//ɓ̃t@Cɐi߂
	//I[o[Ch̕KvȂ;UNLHA32.dllłINDIVIDUALINFOQƂȂ̂Ő삷
	//bool InspectArchiveGetOriginalFileSize(LARGE_INTEGER &FileSize);
	//bool InspectArchiveGetCompressedFileSize(LARGE_INTEGER &FileSize);
	//bool InspectArchiveGetWriteTime(FILETIME &FileTime);
	virtual DWORD InspectArchiveGetCRC();					//ɓt@CCRC擾
	virtual WORD InspectArchiveGetRatio();					//ɓt@Ck擾
	virtual bool InspectArchiveGetMethodString(CString&);			//ɓt@Ci[[h擾
};
