#pragma once

#include "Dlg_Base.h"
#include "../ConfigManager.h"
#include "../../resource.h"
#include "../../ArchiverCode/Archiver7ZIP.h"
#include "../ConfigZIP.h"

//====================================
// ZIP̐ݒ荀
//====================================
class CConfigDlgZIP : public CDialogImpl<CConfigDlgZIP>,public CWinDataExchange<CConfigDlgZIP>,public CMessageFilter,public IConfigDlgBase
{
protected:
	CConfigZIP		m_Config;

	CButton			Radio_CompressType[ZIP_COMPRESS_TYPE_ITEM_COUNT];
	CButton			Radio_CompressLevel[ZIP_COMPRESS_LEVEL_ITEM_COUNT];

	CButton			Check_SpecifyDeflateMemorySize;
	CButton			Check_SpecifyDeflatePassNumber;
	virtual BOOL PreTranslateMessage(MSG* pMsg){
		return IsDialogMessage(pMsg);
	}

public:
	enum { IDD = IDD_PROPPAGE_CONFIG_ZIP };

	// DDX}bv
	BEGIN_DDX_MAP(CConfigDlgZIP)
		DDX_INT_RANGE(IDC_EDIT_ZIP_DEFLATE_MEMORY_SIZE, m_Config.DeflateMemorySize, (int)ZIP_DEFLATE_MEMORY_SIZE_LOWEST, (int)ZIP_DEFLATE_MEMORY_SIZE_HIGHEST)
		DDX_INT_RANGE(IDC_EDIT_ZIP_DEFLATE_PASS_NUMBER, m_Config.DeflatePassNumber, (int)ZIP_DEFLATE_PASS_NUMBER_LOWEST, (int)ZIP_DEFLATE_PASS_NUMBER_HIGHEST)
	END_DDX_MAP()

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDlgZIP)
		MSG_WM_INITDIALOG(OnInitDialog)
		COMMAND_ID_HANDLER(IDC_CHECK_ZIP_SPECIFY_MEMORY_SIZE,OnSpecifyDeflateMemorySize)
		COMMAND_ID_HANDLER(IDC_CHECK_ZIP_SPECIFY_PASS_NUMBER,OnSpecifyDeflatePassNumber)
		MSG_WM_DESTROY(OnDestroy)
	END_MSG_MAP()

	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	LRESULT OnApply();
	LRESULT OnSpecifyDeflateMemorySize(WORD,WORD,HWND,BOOL&);
	LRESULT OnSpecifyDeflatePassNumber(WORD,WORD,HWND,BOOL&);

	void OnDataValidateError(UINT nCtrlID, BOOL bSave, _XData& data){
		CString msg; 
		msg.Format(IDS_ERROR_VALUE_RANGE,data.intData.nMin, data.intData.nMax);
		ErrorMessage(msg);

		::SetFocus(GetDlgItem(nCtrlID));
		::SendMessage(GetDlgItem(nCtrlID),EM_SETSEL,0,-1);
	}

	LRESULT OnDestroy(){
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->RemoveMessageFilter(this);

		return TRUE;
	}

	void LoadConfig(CConfigManager& Config){
		m_Config.load(Config);
	}
	void StoreConfig(CConfigManager& Config){
		m_Config.store(Config);
	}
};

