#include "stdafx.h"
#include "WaitDialog.h"

LRESULT CWaitDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	Static_MessageString=GetDlgItem(IDC_STATIC_WAIT_MESSAGE);
	Static_Icon=GetDlgItem(IDC_STATIC_ANIMATION_ICON);

	CImageList ImageList;
	//ImageList.Create(MAKEINTRESOURCE(IDB_BITMAP_ANIMATION),32,1,RGB(128,128,128));
	ImageList.CreateFromImage(MAKEINTRESOURCE(IDB_BITMAP_ANIMATION),32,1,CLR_DEFAULT,IMAGE_BITMAP,LR_CREATEDIBSECTION);
	int IconCount=ImageList.GetImageCount();
	m_CurrentIconNumber=0;
	m_IconArray.resize(IconCount);
	for(int i=0;i<IconCount;i++){
		m_IconArray[i]=ImageList.ExtractIcon(i);
	}
	m_LastTime=0;

	// eEBhE̒ɔzu
	CenterWindow();

	// bZ[W[vɃbZ[WtB^ƃAChnhǉ
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	m_bAborted=false;
	return TRUE;
}

void CWaitDialog::OnDestroy()
{
	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->RemoveMessageFilter(this);
	pLoop->RemoveIdleHandler(this);

	m_IconArray.clear();
}

void CWaitDialog::AnimationCall()
{
	DWORD Now=timeGetTime();
	if(Now-m_LastTime<200)return;
	m_LastTime=Now;
	m_CurrentIconNumber++;
	m_CurrentIconNumber%=m_IconArray.size();
	Static_Icon.SetIcon(m_IconArray[m_CurrentIconNumber]);
}

void CWaitDialog::Prepare(HWND hWndParent,LPCTSTR lpMsg)
{
	Create(hWndParent);
	SetMessageString(lpMsg);
	ShowWindow(SW_SHOW);
	UpdateWindow();
}
