#pragma once
#include "FileListModel.h"
#include "ShellDataManager.h"
#include "OLE/DnDSource.h"
#include "OLE/DropTarget.h"	//hbv󂯓,IDropCommunicator
#include "../Utilities/TemporaryDirMgr.h"
#include "../resource.h"
#include "FileListMessages.h"
#include "../Utilities/OSUtil.h"

struct CConfigFileListWindow;
class CFileListView:public CWindowImpl<CFileListView,CListViewCtrl>,public CCustomDraw<CFileListView>,public IDropCommunicator//ÕC^[tFCX
{
public:
	DECLARE_WND_SUPERCLASS(NULL, CListViewCtrl::GetWndClassName())
	BOOL PreTranslateMessage(MSG* pMsg){return FALSE;}

	//----------------------
	//IDropCommunicator̎
	HRESULT DragEnter(IDataObject*,POINTL&,DWORD&);
	HRESULT DragLeave();
	HRESULT DragOver(IDataObject*,POINTL&,DWORD&);
	HRESULT Drop(IDataObject*,POINTL&,DWORD&);
protected:
	BEGIN_MSG_MAP_EX(CFileListView)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_DESTROY(OnDestroy)
		MSG_WM_CONTEXTMENU(OnContextMenu)	//ENbNj[
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_SELECT_ALL,OnSelectAll)
		MESSAGE_HANDLER(WM_FILELIST_ARCHIVE_LOADED, OnFileListNewContent)
		MESSAGE_HANDLER(WM_FILELIST_NEWCONTENT, OnFileListNewContent)
		MESSAGE_HANDLER(WM_FILELIST_UPDATED, OnFileListUpdated)
		NOTIFY_CODE_HANDLER(NM_RCLICK, OnColumnRClick)	//Jwb_ENbN
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_DELETE_SELECTED,OnDelete)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_SELECTED,OnExtractItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_SELECTED_SAMEDIR,OnExtractItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_FINDITEM,OnFindItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_FINDITEM_END,OnFindItem)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_ADD_FILE,OnAddItems)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_ADD_DIRECTORY,OnAddItems)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_SHOW_COLUMNHEADER_MENU,OnShowCustomizeColumn)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_OPEN_ASSOCIATION,OnOpenAssociation)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_OPEN_ASSOCIATION_OVERWRITE,OnOpenAssociation)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_EXTRACT_TEMPORARY,OnExtractTemporary)
		COMMAND_ID_HANDLER_EX(ID_MENUITEM_CLEAR_TEMPORARY,OnClearTemporary)
		COMMAND_RANGE_HANDLER_EX(ID_MENUITEM_USERAPP_BEGIN,ID_MENUITEM_USERAPP_END+ms_SendToCmd.size(),OnOpenWithUserApp)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(NM_DBLCLK, OnDblClick)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(NM_RETURN, OnDblClick)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_BEGINDRAG, OnBeginDrag)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_GETINFOTIP, OnGetInfoTip)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_GETDISPINFO, OnGetDispInfo)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_ODFINDITEM, OnFindItem)	//L[^Cvł̌
		REFLECTED_NOTIFY_CODE_HANDLER_EX(LVN_COLUMNCLICK, OnSortItem)
		CHAIN_MSG_MAP_ALT(CCustomDraw<CFileListView>, 1)	// CCustomDrawNXփ`F[
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()
protected:
	int m_ColumnIndexArray[FILEINFO_ITEM_COUNT];	//JCfbNXƃTuACeԍ̑Ή
		/*
		Config.FileListWindow.ColumnOrderArray?ɂ́AJяFILEINFO_TYPE̒lœĂ(\ڂ-1)B
		m_ColumnIndexArrayɂ́Aǂ̃JCfbNXFILEINFO_TYPE\Ă邩Ai[Ă
		m_ColumnIndexArray[яςĂȂԂō琔CfbNX]=FILEINFO_TYPE
		*/

	CConfigManager&				mr_Config;
	CFileListModel&				mr_Model;
	CTemporaryDirectoryManager	m_TempDirMgr;
	CShellDataManager			m_ShellDataManager;
	CImageList					m_SortImageList;
	bool	m_bDisplayFileSizeInByte;
	HWND	m_hFrameWnd;

	COLEDnDSource	m_DnDSource;	//DnDnh
	CDropTarget		m_DropTarget;	//hbv󂯓Ɏg
	int				m_nDropHilight;		//hbvnCCgԂɂACẽCfbNX

	//---uvj[̃R}h
	static std::vector<SHORTCUTINFO> ms_SendToCmd;
	//uvOŊJṽR}h
	static std::vector<CMenuCommandItem> ms_MenuCommandArray;
protected:
	//---Cxgnh
	LRESULT OnCreate(LPCREATESTRUCT lpcs);
	LRESULT OnDestroy();
	LRESULT OnFileListNewContent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnFileListUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);

	LRESULT OnGetDispInfo(LPNMHDR pnmh);
	LRESULT OnGetInfoTip(LPNMHDR pnmh);
	LRESULT OnFindItem(LPNMHDR pnmh);
	LRESULT OnSortItem(LPNMHDR pnmh);
	LRESULT OnBeginDrag(LPNMHDR pnmh);
	LRESULT OnDblClick(LPNMHDR pnmh);
	void OnSelectAll(UINT,int,HWND);
	void OnDelete(UINT,int,HWND);
	void OnContextMenu(HWND,CPoint&);
	void OnExtractItem(UINT,int,HWND);	//It@C
	void OnFindItem(UINT,int,HWND);	//t@C
	void OnShowCustomizeColumn(UINT,int,HWND);	//Jwb_ҏWj[\
	void OnOpenAssociation(UINT,int,HWND);	//ꎞtH_ɓWJt@C֘AtŊJ
	void OnExtractTemporary(UINT,int,HWND);	//ꎞtH_ɓWJ
	void OnClearTemporary(UINT,int,HWND);	//ꎞtH_ɂ
	void OnAddItems(UINT,int,HWND);
	//R}hnh
	void OnOpenWithUserApp(UINT,int,HWND);
public:
	LRESULT OnColumnRClick(int, LPNMHDR pnmh, BOOL& bHandled);//Jwb_ENbN
	//JX^h[
	DWORD OnPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
	DWORD OnItemPrePaint(int nID, LPNMCUSTOMDRAW lpnmcd);
protected:
	//---internal functions
	//t@C擾
	void FormatFileSize(CString&,const LARGE_INTEGER&);
	void FormatFileTime(CString&,const FILETIME&);
	void FormatAttribute(CString&,int);
	void FormatCRC(CString &strBuffer,DWORD dwCRC);
	void FormatRatio(CString &strBuffer,WORD wRatio);
	bool OpenAssociation(bool bOverwrite,bool bOpen);	//bOverwrite:trueȂ瑶݂e|t@C폜Ă𓀂
	void OpenAssociation(const std::list<CString> &filesList);
	bool OnUserApp(const std::vector<CMenuCommandItem> &menuCommandArray,UINT nID);	//uvOŊJṽnh(LhaForgeݒ)
	bool OnSendToApp(UINT nID);	//uvOŊJṽnh(SendToR}h)
	HRESULT AddItems(const std::list<CString> &fileList,LPCTSTR strDest);
	void UpdateSortIcon();
public:
	CFileListView(CConfigManager&,CFileListModel& rModel);
	virtual ~CFileListView(){}
	bool SetColumnState(const int* pColumnOrderArray);	//Xgr[̃JZbg
	void GetColumnState(int* pColumnOrderArray);

	void SetDisplayFileSizeInByte(bool b){m_bDisplayFileSizeInByte=b;}

	void GetSelectedItems(std::list<ARCHIVE_ENTRY_INFO_TREE*>&);
	void EnableDropTarget(bool bEnable);
	void SetFrameWnd(HWND hWnd){m_hFrameWnd=hWnd;}
	static void MakeSendToCommands();
	static void UpdateUserAppCommands(const CConfigFileListWindow&);

	static void MakeUserAppMenu(HMENU);
	static void MakeSendToMenu(HMENU);
};
