#pragma once
#include "ArcFileContent.h"
#include "FileListModel.h"
#include "OLE/DropTarget.h"	//hbv󂯓,IDropCommunicator
#include "FileListMessages.h"

class CFileTreeView:public CWindowImpl<CFileTreeView,CTreeViewCtrl>,public IDropCommunicator//ÕC^[tFCX
{
protected:
	CImageList	m_ImageList;
	typedef std::map<ARCHIVE_ENTRY_INFO_TREE*,HTREEITEM> ITEMDICT;
	ITEMDICT m_TreeItemMap;
	CFileListModel &m_rModel;
	bool m_bSelfAction;
	HWND m_hFrameWnd;
protected:
	//---hbv󂯓
	CDropTarget m_DropTarget;	//hbv󂯓Ɏg
	HTREEITEM m_hDropHilight;	//hbvnCCgԂɂACẽnh
	//IDropCommunicator̎
	HRESULT DragEnter(IDataObject*,POINTL&,DWORD&);
	HRESULT DragLeave();
	HRESULT DragOver(IDataObject*,POINTL&,DWORD&);
	HRESULT Drop(IDataObject*,POINTL&,DWORD&);
protected:
	BEGIN_MSG_MAP_EX(CFileTreeView)
		MSG_WM_CREATE(OnCreate)
		MSG_WM_DESTROY(OnDestroy)
		MESSAGE_HANDLER(WM_FILELIST_ARCHIVE_LOADED, OnFileListArchiveLoaded)
		MESSAGE_HANDLER(WM_FILELIST_NEWCONTENT, OnFileListNewContent)
		MESSAGE_HANDLER(WM_FILELIST_UPDATED, OnFileListUpdated)
		//NOTIFY_CODE_HANDLER_EX(NM_CLICK, OnClick)
		REFLECTED_NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSelect)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()

protected:
	//---internal functions
	LRESULT OnCreate(LPCREATESTRUCT lpcs);
	LRESULT OnDestroy();

	LRESULT OnTreeSelect(LPNMHDR);
	LRESULT OnFileListArchiveLoaded(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnFileListNewContent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnFileListUpdated(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	bool UpdateCurrentNode();

	bool IsSelfAction(){return m_bSelfAction;}
	void BeginSelfAction(){m_bSelfAction=true;}
	void EndSelfAction(){m_bSelfAction=false;}
public:
	DECLARE_WND_SUPERCLASS(NULL, CTreeViewCtrl::GetWndClassName())
	BOOL PreTranslateMessage(MSG* pMsg){return FALSE;}

	CFileTreeView(CFileListModel&);
	virtual ~CFileTreeView(){}
	bool ConstructTree(HTREEITEM hParentItem=NULL,ARCHIVE_ENTRY_INFO_TREE* lpNode=NULL);
	void Clear();
	void ExpandTree();

	void EnableDropTarget(bool bEnable);
	void SetFrameWnd(HWND hWnd){m_hFrameWnd=hWnd;}
};
