#include "stdafx.h"
#include "FileOperation.h"
#include "Utility.h"
#include "StringUtil.h"


#if !defined(_UNICODE)&&!defined(UNICODE)
 #include <imagehlp.h> //MakeSureDirectoryPathExists()
#endif


bool UtilGetTemporaryFileName(LPTSTR fname,LPCTSTR prefix)
{
	TCHAR TempDirPath[_MAX_PATH+1];
	FILL_ZERO(TempDirPath);
	GetTempPath(_MAX_PATH,TempDirPath);
	if(!GetTempFileName(TempDirPath,prefix,0,fname)){
		return false;
	}
	return true;
}

bool UtilGetTemporaryFileNameA(LPSTR fname,LPCSTR prefix)
{
	char TempDirPath[_MAX_PATH+1];
	FILL_ZERO(TempDirPath);
	GetTempPathA(_MAX_PATH,TempDirPath);
	if(!GetTempFileNameA(TempDirPath,prefix,0,fname)){
		return false;
	}
	return true;
}

bool UtilDeletePath(LPCTSTR PathName)
{
	if(PathIsDirectory(PathName)){//fBNg
		//t@C̑Wɖ߂
		SetFileAttributes(PathName,FILE_ATTRIBUTE_NORMAL);
		if(RemoveDirectory(PathName))return true;
	}
	else if(PathFileExists(PathName)){//t@C
		//t@C̑Wɖ߂
		SetFileAttributes(PathName,FILE_ATTRIBUTE_NORMAL);
		if(DeleteFile(PathName))return true;
	}
	return false;
}

//bDeleteParent=truêƂAPathg폜
//bDeleteParent=falsêƂ́APath̒g폜
bool UtilDeleteDir(LPCTSTR Path,bool bDeleteParent)
{
	WIN32_FIND_DATA lp;

	TCHAR FindParam[_MAX_PATH+1];
	FILL_ZERO(FindParam);
	_tcsncpy_s(FindParam,Path,_MAX_PATH);
	PathAppend(FindParam,_T("*"));
	HANDLE h=FindFirstFile(FindParam,&lp);

	bool bRet=true;

	do{
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)&& 0!=_tcscmp(lp.cFileName,_T("..")) && 0!=_tcscmp(lp.cFileName,_T(".")))
		{
			CString SubPath=Path;
			SubPath+=_T("\\");
			SubPath+=lp.cFileName;

			bRet=bRet&&UtilDeleteDir(SubPath,true);
		}
		if((lp.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)!=FILE_ATTRIBUTE_DIRECTORY)
		{
			// lp.cFileNameŃt@C
			TCHAR FileName[_MAX_PATH+1];
			FILL_ZERO(FileName);
			_tcsncpy_s(FileName,Path,_MAX_PATH);
			PathAppend(FileName,lp.cFileName);

			bRet=bRet&&UtilDeletePath(FileName);
		}
	}while(FindNextFile(h,&lp));

	FindClose(h);
	if(bDeleteParent){
		bRet=bRet&&UtilDeletePath(Path);
	}

	return bRet;
}


//ǂݎ茳t@Cݐt@Cseek̂ӏɃRs[ď
//߂l̓G[ȂȂ0,ǂݎG[1,݃G[-1
int UtilAppendFile(HANDLE hWriteTo,HANDLE hReadFrom)
{
	//16KBRs[
	DWORD dwRead=0,dwWrite=0;
	std::vector<BYTE> Buffer(16*1024);
	for(;;){
		if(!ReadFile(hReadFrom,&Buffer.at(0),16*1024,&dwRead,NULL)){
			return 1;
		}
		if(0==dwRead){
			break;
		}
		if(!WriteFile(hWriteTo,&Buffer.at(0),dwRead,&dwWrite,NULL)){
			return -1;
		}
		if(dwRead!=dwWrite){
			return -1;
		}
	}
	return 0;
}

void UtilModifyPath(CString &strPath)
{
	// pX̏C
	strPath.Replace(_T("/"),_T("\\"));	//pX؂蕶

	int Ret=0;
	do{
		Ret=strPath.Replace(_T("\\\\"),_T("\\"));	//\\\ɒuĂ
	}while(Ret!=0);
	strPath.Replace(_T("..\\"),_T("__\\"));	//΃pXw..__ɒu
	strPath.Replace(_T(":"),_T("__"));	//hCuu(C:C__)
}

BOOL UtilMoveFileToRecycleBin(LPCTSTR lpFileName)
{
	ASSERT(lpFileName);
	if(!lpFileName)return false;
	const UINT len=_tcslen(lpFileName);
	std::vector<TCHAR> Buffer(len+2);
	_tcsncpy_s(&Buffer[0],len+1,lpFileName,len+1);
	Buffer.back()=_T('\0');

	SHFILEOPSTRUCT shfo={0};
	shfo.wFunc=FO_DELETE;	//폜
	shfo.pFrom=&Buffer[0];//t@C̃Xg\0\0ŏIKvL
	shfo.fFlags=FOF_SILENT/*i󋵂\Ȃ*/|FOF_ALLOWUNDO/*UNDOt;ݔ*/|FOF_NOCONFIRMATION/*mF_CAO\Ȃ*/;
	return SHFileOperation(&shfo);
}

BOOL UtilMoveFileToRecycleBin(const std::list<CString> &fileList)
{
	ASSERT(!fileList.empty());
	if(fileList.empty())return false;

	//쐬
	CString Param;
	for(std::list<CString>::const_iterator ite=fileList.begin();ite!=fileList.end();++ite){
		Param+=*ite;
		Param+=_T('|');
	}
	Param+=_T('|');
	std::vector<TCHAR> Buffer(Param.GetLength()+1);

	UtilMakeFilterString(Param,&Buffer[0],Buffer.size());

	SHFILEOPSTRUCT shfo={0};
	shfo.wFunc=FO_DELETE;	//폜
	shfo.pFrom=&Buffer[0];//t@C̃Xg\0\0ŏIKvL
	shfo.fFlags=FOF_SILENT/*i󋵂\Ȃ*/|FOF_ALLOWUNDO/*UNDOt;ݔ*/|FOF_NOCONFIRMATION/*mF_CAO\Ȃ*/;
	return SHFileOperation(&shfo);
}

//tH_t@C(fBNg͏)ċA
bool UtilRecursiveEnumFile(LPCTSTR lpszRoot,std::list<CString> &rFileList)
{
	CFindFile cFindFile;
	TCHAR szPath[_MAX_PATH+1];
	_tcsncpy_s(szPath,lpszRoot,_MAX_PATH);
	PathAppend(szPath,_T("*"));

	BOOL bContinue=cFindFile.FindFile(szPath);
	while(bContinue){
		if(!cFindFile.IsDots()){
			if(cFindFile.IsDirectory()){
				UtilRecursiveEnumFile(cFindFile.GetFilePath(),rFileList);
			}else{
				rFileList.push_back(cFindFile.GetFilePath());
			}
		}
		bContinue=cFindFile.FindNextFile();
	}

	return !rFileList.empty();
}

//tpX΃pX̎擾
PATHERROR UtilGetCompletePathName(CString &_FullPath,LPCTSTR lpszFileName)
{
	ASSERT(lpszFileName&&_tcslen(lpszFileName)>0);
	if(!lpszFileName||_tcslen(lpszFileName)<=0){
		TRACE(_T("t@Cw肳ĂȂ\n"));
		return PATHERROR_INVALID;
	}

	//---΃pX擾
	TCHAR szAbsPath[_MAX_PATH+1]={0};
	{
		TCHAR Buffer[_MAX_PATH+1]={0};	//[gǂ̃`FbNs
		_tcsncpy_s(Buffer,lpszFileName,_MAX_PATH);
		PathAddBackslash(Buffer);
		if(PathIsRoot(Buffer)){
			//hCuw肳ĂꍇA
			//_tfullpath͂̃hCũJgfBNg擾Ă܂
			_tcsncpy_s(szAbsPath,lpszFileName,_MAX_PATH);
		}
		else if(!_tfullpath(szAbsPath,lpszFileName,_MAX_PATH)){
			TRACE(_T("΃pX擾s\n"));
			return PATHERROR_ABSPATH;
		}
	}

	if(!PathFileExists(szAbsPath)&&!PathIsDirectory(szAbsPath)){
		//pXt@C̓fBNgƂđ݂ȂȂAG[Ƃ
		TRACE(_T("t@C݂Ȃ\n"));
		return PATHERROR_NOTFOUND;
	}
	if(!GetLongPathName(szAbsPath,szAbsPath,_MAX_PATH)){
		TRACE(_T("Ot@C擾s\n"));
		return PATHERROR_LONGNAME;
	}
	_FullPath=szAbsPath;
	return PATHERROR_NONE;
}

//΃pX̎擾
bool UtilGetAbsPathName(CString &_FullPath,LPCTSTR lpszFileName)
{
	ASSERT(lpszFileName&&_tcslen(lpszFileName)>0);
	if(!lpszFileName||_tcslen(lpszFileName)<=0){
		TRACE(_T("t@Cw肳ĂȂ\n"));
		return false;
	}

	//---΃pX擾
	TCHAR szAbsPath[_MAX_PATH+1]={0};
	{
		TCHAR Buffer[_MAX_PATH+1]={0};	//[gǂ̃`FbNs
		_tcsncpy_s(Buffer,lpszFileName,_MAX_PATH);
		PathAddBackslash(Buffer);
		if(PathIsRoot(Buffer)){
			//hCuw肳ĂꍇA
			//_tfullpath͂̃hCũJgfBNg擾Ă܂
			_tcsncpy_s(szAbsPath,lpszFileName,_MAX_PATH);
		}
		else if(!_tfullpath(szAbsPath,lpszFileName,_MAX_PATH)){
			TRACE(_T("΃pX擾s\n"));
			return false;
		}
	}

	_FullPath=szAbsPath;
	return true;
}

//ChJ[h̓WJ
bool UtilPathExpandWild(std::list<CString> &r_outList,const std::list<CString> &r_inList)
{
	std::list<CString> tempList;
	std::list<CString>::const_iterator ite=r_inList.begin();
	const std::list<CString>::const_iterator end=r_inList.end();
	for(;ite!=end;++ite){
		if(-1==(*ite).FindOneOf(_T("*?"))){	//ChWJ\ȕ͂Ȃ
			tempList.push_back(*ite);
		}else{
			//ChWJ
			CFindFile cFindFile;
			BOOL bContinue=cFindFile.FindFile(*ite);
			while(bContinue){
				if(!cFindFile.IsDots()){
					tempList.push_back(cFindFile.GetFilePath());
				}
				bContinue=cFindFile.FindNextFile();
			}
		}
	}
	r_outList=tempList;
	return true;
}


bool UtilPathExpandWild(std::list<CString> &r_outList,const CString &r_inParam)
{
	std::list<CString> tempList;
	if(-1==r_inParam.FindOneOf(_T("*?"))){	//ChWJ\ȕ͂Ȃ
		tempList.push_back(r_inParam);
	}else{
		//ChWJ
		CFindFile cFindFile;
		BOOL bContinue=cFindFile.FindFile(r_inParam);
		while(bContinue){
			if(!cFindFile.IsDots()){
				tempList.push_back(cFindFile.GetFilePath());
			}
			bContinue=cFindFile.FindNextFile();
		}
	}
	r_outList=tempList;
	return true;
}

//pX̃fBNgo
void UtilPathGetDirectoryPart(CString &str)
{
	LPTSTR lpszBuf=str.GetBuffer(_MAX_PATH+1);
	PathRemoveFileSpec(lpszBuf);
	PathAddBackslash(lpszBuf);
	str.ReleaseBuffer();
}

//̃vÕt@CԂ
LPCTSTR UtilGetModulePath()
{
	static TCHAR s_szExePath[_MAX_PATH+1]={0};
	if(s_szExePath[0]!=_T('\0'))return s_szExePath;

	GetModuleFileName(GetModuleHandle(NULL), s_szExePath, _MAX_PATH);	//{̂̃pX擾
	return s_szExePath;
}

//̃vÔĂfBNg̃pXԂ
LPCTSTR UtilGetModuleDirectoryPath()
{
	static TCHAR s_szDirPath[_MAX_PATH+1]={0};
	if(s_szDirPath[0]!=_T('\0'))return s_szDirPath;

	GetModuleFileName(GetModuleHandle(NULL), s_szDirPath, _MAX_PATH);	//{̂̃pX擾
	PathRemoveFileSpec(s_szDirPath);
	return s_szDirPath;
}

//Kw̃fBNgCɍ쐬
BOOL UtilMakeSureDirectoryPathExists(LPCTSTR _lpszPath)
{
#if defined(_UNICODE)||defined(UNICODE)
	CPath path(_lpszPath);
	path.RemoveFileSpec();
	path.AddBackslash();

	//TODO:UNICODEł݂̂Ń`FbNĂ̂ANSIrhɂ͓KXׂ
	CString tmp(path);
	if(-1!=tmp.Find(_T(" \\"))||-1!=tmp.Find(_T(".\\"))){	//pXƂďłȂt@C
		return FALSE;
	}

	//UNICODEł݂̂ŕKvȃ`FbN
	if(path.IsRoot())return TRUE;	//hCu[gȂ쐬Ȃ(łȂ)

	int nRet=SHCreateDirectoryEx(NULL,path,NULL);
	switch(nRet){
	case ERROR_SUCCESS:
		return TRUE;
	case ERROR_ALREADY_EXISTS:
		if(path.IsDirectory())return TRUE;	//łɃfBNgꍇZ[tƂ
		else return FALSE;
	default:
		return FALSE;
	}
#else//defined(_UNICODE)||defined(UNICODE)
  #pragma comment(lib, "Dbghelp.lib")
	return MakeSureDirectoryPathExists(_lpszPath);
#endif//defined(_UNICODE)||defined(UNICODE)
}

//TCHARt@CSJISt@CɕϊBϊłȂꍇɂ́AfalseԂ
bool UtilPathT2A(CStringA &strA,LPCTSTR lpPath,bool bOnDisk)
{
#if defined(_UNICODE)||defined(UNICODE)
	CStringA strTemp(lpPath);
	if(strTemp==lpPath){
		//ϊł
		strA=strTemp;
		return true;
	}
	if(!bOnDisk){
		//fBXÑt@Cł͂Ȃ̂ŁAȍ~̑֎i͎Ȃ
		return false;
	}
	//V[gt@CőpĂ݂
	WCHAR szPath[_MAX_PATH+1];
	GetShortPathNameW(lpPath,szPath,_MAX_PATH+1);

	//SJISɕϊłĂ邩ǂ`FbN
	return UtilPathT2A(strA,szPath,false);

#else//defined(_UNICODE)||defined(UNICODE)
	//SJIŜ܂
	strA=lpPath;
	return true;
#endif//defined(_UNICODE)||defined(UNICODE)
}

//pXɋʂ镔oApXo
void UtilGetBaseDirectory(CString &BasePath,const std::list<CString> &PathList)
{
	bool bFirst=true;
	size_t ElementsCount=0;	//ʍڐ
	std::vector<CString> PathElements;	//ʍڂ̔z

	std::list<CString>::const_iterator ite,end;
	end=PathList.end();
	for(ite=PathList.begin();ite!=end;++ite){
		if(!bFirst&&0==ElementsCount){
			//ɋʂĂvfzɑ݂ȂƂ
			break;
		}

		//efBNg܂łŏIpX
		TCHAR Path[_MAX_PATH+1];
		FILL_ZERO(Path);
		_tcsncpy_s(Path,*ite,_MAX_PATH);
		PathRemoveFileSpec(Path);
		PathAddBackslash(Path);

		CString buffer;
		size_t iElement=0;	//vĂpX̗vf̃JEgp([v)
		size_t iIndex=0;	//pX̃̕CfbNX
		const size_t Length=_tcslen(Path);
		for(;iIndex<Length;iIndex++){
#if !defined(_UNICODE)&&!defined(UNICODE)
			if(_MBC_SINGLE==_mbsbtype((const unsigned char *)Path,iIndex)){
#endif
				if(_T('\\')==Path[iIndex]){
					//ȂpXlߍ݁AłȂΗvfr
					if(bFirst){
//						TRACE(_T("Feed:First:%s\n"),buffer);
						PathElements.push_back(buffer);
						buffer.Empty();
						continue;
					}
					else{
						//啶ʂɔr
						if(0==PathElements[iElement].CompareNoCase(buffer)){
//							TRACE(_T("pXvfv\n"));
							//vfʂĂ邤OK
							iElement++;
							if(iElement>=ElementsCount)break;
							else{
								buffer.Empty();
								continue;
							}
						}
						else
						{
							//vf炷
							//0IWiԖڂŕsvȂi܂ňv
							ElementsCount=iElement;
//							TRACE(_T("sv:iElement=%d\n"),iElement);
							break;
						}
					}
				}
#if !defined(_UNICODE)&&!defined(UNICODE)
			}
#endif
			buffer+=Path[iIndex];
		}
		if(bFirst){
			bFirst=false;
			ElementsCount=PathElements.size();
//			TRACE(_T("ElementsCount=%d\n"),ElementsCount);
		}
		else if(ElementsCount>iElement){
			//pXZꍇAsvȂ̂܂܏Iꍇ
			ElementsCount=iElement;
//			TRACE(_T("pXZ:%s:iElement=%d\n"),*ite,iElement);
		}
	}

	BasePath.Empty();
	for(size_t i=0;i<ElementsCount;i++){
		BasePath+=PathElements[i];
		BasePath+=_T("\\");
	}
	TRACE(_T("BasePath=%s\n"),BasePath);
}

const LPCTSTR c_InvalidPathChar=_T("\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\"<>|:*?\\/\b\t");

//t@CɎgȂu
void UtilFixFileName(CString &rStr,LPCTSTR lpszOrg,TCHAR replace)
{
	rStr=lpszOrg;
	int length=_tcslen(c_InvalidPathChar);
	for(int i=0;i<length;i++){
		rStr.Replace(c_InvalidPathChar[i],replace);
	}
}


LPCTSTR UtilPathNextSeparator(LPCTSTR lpStr)
{
	for(;*lpStr!=_T('\0');lpStr++){
		if(*lpStr==_T('/') || *lpStr==_T('\\')){
			break;
		}
	}
	//I[
	return lpStr;
}

bool UtilPathNextSection(LPCTSTR lpStart,LPCTSTR& r_lpStart,LPCTSTR& r_lpEnd,bool bSkipMeaningless)
{
	LPCTSTR lpEnd=UtilPathNextSeparator(lpStart);
	if(bSkipMeaningless){
		while(true){
			//---ȃpXǂ`FbN
			//2ȏ̃pX͗LłƌȂ

			int length=lpEnd-lpStart-1;
			if(length<=0 || (1==length && _T('.')==*lpStart)){	//ȃpX
				if(_T('\0')==*lpEnd){	//pX̗vfȂȂ̂ŕԂ
					return false;
				}
				if(length<0)lpEnd++;

				//̗vfĂ
				lpStart=lpEnd;
				lpEnd=UtilPathNextSeparator(lpStart);
			}else{
				break;
			}
		}
	}
	r_lpStart=lpStart;
	r_lpEnd=lpEnd;
	return true;
}

//Path'/''\\'ŏIĂȂtrue
bool UtilPathEndWithSeparator(LPCTSTR lpPath)
{
	UINT length=_tcslen(lpPath);
	TCHAR c=lpPath[length-1];
	return (_T('/')==c || _T('\\')==c);
}

//pX̍Ō̕o
void UtilPathGetLastSection(CString &strSection,LPCTSTR lpPath)
{
	CString strPath=lpPath;
	strPath.Replace(_T('\\'),_T('/'));
	while(true){
		int idx=strPath.ReverseFind(_T('/'));
		if(-1==idx){	//̂܂
			strSection=lpPath;
			return;
		}else if(idx<strPath.GetLength()-1){
			//Separatorł͂Ȃ
			strSection=lpPath+idx+1;
			return;
		}else{	//Separator
			//->̓[vōēx;strSectionɂSeparatort̕i[
			strPath.Delete(idx,strPath.GetLength());
		}
	}
}



//t@CۂƁA͎w肳ꂽƂ܂œǂݍ(-1Ŋۂ)
bool UtilReadFile(LPCTSTR lpFile,std::vector<BYTE> &cReadBuffer,DWORD dwLimit)
{
	ASSERT(lpFile);
	if(!lpFile)return false;
	if(!PathFileExists(lpFile))return false;

	//Open
	HANDLE hFile=CreateFile(lpFile,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)return false;

	//4GBzt@C͈Ȃ̂Ńt@CTCY擾͂ł悢
	DWORD dwSize=GetFileSize(hFile,NULL);

	//ǂݍݔ͈
	if(-1!=dwLimit){	//͈͐Ă
		dwSize=min(dwSize,dwLimit);
	}

	cReadBuffer.resize(dwSize);
	DWORD dwRead,dwIndex=0;
	//---ǂݍ
/*	ꊇǂݍ݂̃R[h
	if(!ReadFile(hFile,&cReadBuffer[0],dwSize,&dwRead,NULL)||dwSize!=dwRead){
		CloseHandle(hFile);
		return false;
	}*/
	while(true){
		const DWORD BLOCKSIZE=1024*10;	//10KBƂɓǂݍ
		DWORD readsize=BLOCKSIZE;
		if(dwIndex+readsize>dwSize){
			readsize=dwSize-dwIndex;
		}
		if(!ReadFile(hFile,&cReadBuffer[dwIndex],readsize,&dwRead,NULL)){
			CloseHandle(hFile);
			return false;
		}
		dwIndex+=dwRead;
		if(readsize<BLOCKSIZE)break;	//ǂݐ؂
	}
	CloseHandle(hFile);

	if(dwSize!=dwIndex){
		return false;
	}

	return true;
}

bool UtilReadFileSplitted(LPCTSTR lpFile,FILELINECONTAINER &container)
{
	//sobt@NA
	container.data.clear();
	container.lines.clear();

	//---ǂݍ
	std::vector<BYTE> cReadBuffer;
	if(!UtilReadFile(lpFile,cReadBuffer))return false;
	//I[0ǉ
	cReadBuffer.resize(cReadBuffer.size()+2);
	cReadBuffer[cReadBuffer.size()-1];
	cReadBuffer[cReadBuffer.size()-2];

	{
		CStringW strData;
		UtilGuessToUNICODE(strData,&cReadBuffer[0],cReadBuffer.size());
		container.data.assign((LPCWSTR)strData,(LPCWSTR)strData+strData.GetLength());
		container.data.push_back(L'\0');
	}


	LPWSTR p=&container.data[0];
	const LPCWSTR end=p+container.data.size();
	LPCWSTR lastHead=p;

	//
	for(;p!=end && *p!=L'\0';p++){
		if(*p==_T('\n')||*p==_T('\r')){
			if(lastHead<p){	//s͔΂
				container.lines.push_back(lastHead);
			}
			lastHead=p+1;
			*p=L'\0';
		}
	}
	return true;
}
