#include "stdafx.h"
#include "variant.h"

LPCTSTR CVariant::getRawValue()const
{
	return m_str;
}

bool CVariant::isEmpty()const
{
	return m_str.IsEmpty();
}

bool CVariant::isNumber()const
{
	float f;
	int ret=_stscanf_s(m_str,_T("%f"),&f);
	if(0==ret||EOF==ret)return false;
	return true;
}

//---

CVariant::operator int()const
{
	return _ttoi(m_str);
}

CVariant::operator float()const
{
	return (float)_tstof(m_str);
}

CVariant::operator LPCTSTR()const
{
	return (LPCTSTR)m_str;
}

//---compare
bool CVariant::operator==(int nValue)const
{
	return operator int()==nValue;
}

bool CVariant::operator==(float fValue)const
{
	return operator float()==fValue;
}

bool CVariant::operator==(LPCTSTR lpszValue)const
{
	return m_str==lpszValue;
}

bool CVariant::operator==(const CVariant &v)const
{
	return m_str==v.m_str;
}

//---let
CVariant& CVariant::operator=(int nValue)
{
	m_str.Format(_T("%d"),nValue);
	return *this;
}

CVariant& CVariant::operator=(float fValue)
{
	m_str.Format(_T("%.10g"),fValue);
	return *this;
}

CVariant& CVariant::operator=(LPCTSTR lpszValue)
{
	m_str=lpszValue;
	return *this;
}

CVariant& CVariant::operator=(const CVariant& v)
{
	m_str=v.m_str;
	return *this;
}


//----------
float CVariant::GetFParam(float fDefault)
{
	if(m_str.IsEmpty())return fDefault;
	return (float)_tstof(m_str);
}

int CVariant::GetNParam(int nDefault)
{
	if(m_str.IsEmpty())return nDefault;
	return _tstoi(m_str);
}

int CVariant::GetNParam(int nMin,int nMax,int nDefault)
{
	if(m_str.IsEmpty())return nDefault;
	int ret=_tstoi(m_str);
	if(ret<nMin || nMax<ret){
		return nDefault;
	}else{
		return ret;
	}
}


//----------
bool operator==(int nValue, const CVariant& v)
{
	return v==nValue;
}

bool operator==(LPCTSTR lpszValue, const CVariant& v)
{
	return v==lpszValue;
}

bool operator==(float fValue, const CVariant& v)
{
	return v==fValue;
}

