#include "stdafx.h"
#include "main.h"
#include "resource.h"
#include "ConfigCode/configwnd.h"
#include "compress.h"
#include "extract.h"
#include "TestArchive.h"
#include "ArchiverCode/arc_interface.h"
#include "FileListWindow/FileListFrame.h"
#include "ArchiverManager.h"
#include "Dialogs/SelectDlg.h"
#include "Dialogs/ProgressDlg.h"
#include "Utilities/OSUtil.h"
#include "Utilities/StringUtil.h"
#include "Update.h"

//EXEɃRg𖄂ߍł
//#pragma comment(exestr,_T("LhaForge by Claybird : This is an Archiver, using Common Archivers Library DLLs."))

CAppModule _Module;


//---------------------------------------------

//Gg[|Cg
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpCmdLine, int nCmdShow)
{
#if defined(_DEBUG)
	// [Nop
	_CrtSetDbgFlag(
		_CRTDBG_ALLOC_MEM_DF
		| _CRTDBG_LEAK_CHECK_DF
		);
#endif
	_tsetlocale(LC_ALL,_T(""));	//P[ϐ擾

	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));
	OleInitialize(NULL);
	// Microsoft Layer for Unicode (MSLU) gpꂽ
	// ATLEChE thunking 
	::DefWindowProc(NULL, 0, 0, 0L);

	// ̃Rg[T|[g邽߂̃tOǉ
	AtlInitCommonControls(ICC_WIN95_CLASSES|ICC_COOL_CLASSES | ICC_BAR_CLASSES);
	_Module.Init(NULL,hInstance);
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	//*********************************
	// R}hCp[^̉
	//*********************************
	/*
	IvVw`:

	/b2e		B2E32.dllgp
	/c:???		???`Ŏw肳ꂽt@Ck(???=lzh,zip,etc...)
	/method:???	???\bhgĈk(B2Ê)
	/b2esfx		ȉ𓀌`ňk(B2Ê)
	/e			t@C
	/o:[dir]	o͐fBNgw
	/l			A[JCut@C̃Xg\(P)
	/f:[file]	ko̓t@C̎w(pXw͖)
	/xacrett	XacRett.DLLIɎgp(/{)
	/!			/xacrettƓ
	/m			t@C𓀂̓Xg\(ݒɂύX)
	/s			t@CEtH_k
	/t			A[JCut@C̊SeXg
	/@[file]	X|Xt@Cw
	/$[file]	X|Xt@Cw:X|Xt@C͓ǂݎ芮폜

	*/

	bool bCheckUpdate=true;	//LFCaldixNȂtrue

	CMDLINEINFO cli;	//CommandLineInfo

	CConfigManager ConfigManager;
	CString strErr;
	if(!ConfigManager.LoadConfig(strErr)){
		ErrorMessage(strErr);
	}
	PROCESS_MODE ProcessMode=ParseCommandLine(ConfigManager,cli);
	if(PROCESS_LIST!=ProcessMode && cli.FileList.empty()){
		//t@CꗗEBhEoꍇȊÓAt@Cw肪Ƃ͐ݒ_CAOo
		ProcessMode=PROCESS_CONFIGURE;
	}
	CArchiverDLLManager::GetInstance().SetConfigManager(ConfigManager);

	//DLLCXg[擾%PATH%ɒǉ
	CConfigUpdate ConfUpdate;
	ConfUpdate.load(ConfigManager);
	{
		//---Vϐ
		CString strPath=ConfUpdate.strDLLPath;
		if(!strPath.IsEmpty()){
			strPath+=_T(";");

			//---ϐ擾
			int len=GetEnvironmentVariable(_T("PATH"),NULL,0);
			CString strEnv;
			GetEnvironmentVariable(_T("PATH"),strEnv.GetBuffer(len+1),len);
			strEnv.ReleaseBuffer();

			strPath+=strEnv;
			SetEnvironmentVariable(_T("PATH"),strPath);
		}
	}

	switch(ProcessMode){
	case PROCESS_COMPRESS://k
		DoCompress(ConfigManager,cli);
		break;
	case PROCESS_EXTRACT://
		DoExtract(ConfigManager,cli);
		break;
	case PROCESS_AUTOMATIC://C
		if(PathIsDirectory(*cli.FileList.begin())){
			DoCompress(ConfigManager,cli);
		}else{
			CConfigExtract ConfExtract;
			ConfExtract.load(ConfigManager);
			if(CArchiverDLLManager::GetInstance().GetArchiver(*cli.FileList.begin(),ConfExtract.DenyExt,cli.idForceDLL)){	//𓀉\Ȍ`ǂ
				DoExtract(ConfigManager,cli);
			}else{
				DoCompress(ConfigManager,cli);
			}
		}
		break;
	case PROCESS_LIST://Xg\
		DoList(ConfigManager,cli);
		break;
	case PROCESS_TEST://A[JCut@C̃eXg
		DoTest(ConfigManager,cli);
		break;
	case PROCESS_CONFIGURE://ݒʕ\
		{
			//ŊmFŝŏI̊mF͕sv
			bCheckUpdate=false;
			//DLLXVmF
			if(CheckUpdateArchiverDLLRequired(ConfUpdate)){
				DoUpdateArchiverDLL(ConfigManager);
			}
			//_CAO\
			CConfigDialog confdlg(ConfigManager);
			if(IDOK==confdlg.DoModal()){
				if(!ConfigManager.SaveConfig(strErr)){
					ErrorMessage(strErr);
				}
			}
		}
		break;
	case PROCESS_INVALID:
		TRACE(_T("Process Mode Undefined\n"));
		break;
	default:
		ASSERT(!"Unexpected Process Mode");
	}
	//Abvf[g`FbN
	if(bCheckUpdate){
		//DLLXVmF
		if(CheckUpdateArchiverDLLRequired(ConfUpdate)){
			DoUpdateArchiverDLL(ConfigManager);
		}
	}

	TRACE(_T("Terminating...\n"));
	CArchiverDLLManager::GetInstance().Final();
//	Sleep(1);	//ΏǗÖ@ for 0xC0000005: Access Violation
	_Module.RemoveMessageLoop();
	_Module.Term();
	OleUninitialize();
	::CoUninitialize();
	TRACE(_T("Exit main()\n"));
	return 0;
}

bool DoCompress(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	//kIvVw
	CString strFormat=cli.strFormat;
	CString strMethod=cli.strMethod;
	CString strLevel=cli.strLevel;

	if(cli.idForceDLL==DLL_ID_B2E){
		cli.CompressType=PARAMETER_B2E;
	}

	CConfigCompress ConfCompress;
	CConfigGeneral ConfGeneral;
	ConfCompress.load(ConfigManager);
	ConfGeneral.load(ConfigManager);

	while(PARAMETER_UNDEFINED==cli.CompressType || PARAMETER_B2E==cli.CompressType){	//---gpDLL
		if(PARAMETER_UNDEFINED==cli.CompressType){	//`w肳ĂȂꍇ
			if(ConfCompress.UseDefaultParameter){	//ftHgp[^gȂf[^擾
				cli.CompressType=ConfCompress.DefaultType;
				cli.Options=ConfCompress.DefaultOptions;

				if(cli.CompressType==PARAMETER_B2E){	//B2Egpꍇ
					cli.idForceDLL=DLL_ID_B2E;	//B2E32.dll̎gp𖾎
					//p[^w
					if(cli.Options)cli.Options=COMPRESS_SFX;	//ȉ
					cli.strFormat=ConfCompress.DefaultB2EFormat;	//`
					cli.strMethod=ConfCompress.DefaultB2EMethod;	//\bh
				}
			}else{	//͂𑣂
				CSelectDialog SelDlg;
				cli.CompressType=(PARAMETER_TYPE)SelDlg.DoModal();
				if(PARAMETER_UNDEFINED==cli.CompressType){	//LZ̏ꍇ
					return false;
				}else if(cli.CompressType!=PARAMETER_B2E){
					cli.idForceDLL=DLL_ID_UNKNOWN;

					cli.Options=SelDlg.GetOptions();
					cli.bSingleCompression=SelDlg.IsSingleCompression();
					break;
				}
			}
		}
		if(cli.CompressType==PARAMETER_B2E){	//B2Egpꍇ
			//---B2E32.dll̃`FbN
			CArchiverB2E &B2EHandler=CArchiverDLLManager::GetInstance().GetB2EHandler();
			if(!B2EHandler.IsOK()){
				cli.CompressType=PARAMETER_UNDEFINED;
				CString msg;
				msg.Format(IDS_ERROR_DLL_LOAD,B2EHandler.GetName());
				ErrorMessage(msg);
				continue;
//				return false;
			}

			//---`I
			if(cli.strFormat.IsEmpty()){
				CB2ESelectDialog SelDlg;
				INT_PTR Ret=SelDlg.DoModal();
				if(IDCANCEL==Ret){	//LZ̏ꍇ
					return false;
				}else if(IDC_COMPRESS_USENORMAL==Ret){	//ʏDLLg
					cli.CompressType=PARAMETER_UNDEFINED;
				}else{
					cli.idForceDLL=DLL_ID_B2E;

					cli.Options=SelDlg.IsSFX() ? COMPRESS_SFX : 0;
					cli.bSingleCompression=SelDlg.IsSingleCompression();
					strFormat=SelDlg.GetFormat();
					strMethod=SelDlg.GetMethod();
					break;
				}
			}else{
				strFormat=cli.strFormat;
				strMethod=cli.strMethod;
				break;
			}
		}
	}

	//--------------------
	// k

	if(cli.bSingleCompression){	//t@Ck
		//vOXo[
		CProgressDialog dlg;
		int nFiles=cli.FileList.size();
		if(nFiles>=2){	//t@C鎞Ɍ
			dlg.Create(NULL);
			dlg.SetTotalFileCount(nFiles);
			dlg.ShowWindow(SW_SHOW);
		}
		bool bRet=true;
		for(std::list<CString>::iterator ite=cli.FileList.begin();ite!=cli.FileList.end();ite++){
			//vOXo[i߂
			if(dlg.IsWindow())dlg.SetNextState(*ite);

			//k
			std::list<CString> TempList;
			TempList.push_back(*ite);

			bRet=bRet && Compress(TempList,cli.CompressType,ConfigManager,cli.Options,strFormat,strMethod,strLevel,cli.OutputFileName,cli.OutputDir);
		}
		//vOXo[
		if(dlg.IsWindow())dlg.DestroyWindow();
		return bRet;
	}else{	//ʏ툳k
		return Compress(cli.FileList,cli.CompressType,ConfigManager,cli.Options,strFormat,strMethod,strLevel,cli.OutputFileName,cli.OutputDir);
	}
}

bool DoExtract(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,true);
	if(cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}
	return Extract(cli.FileList,ConfigManager,cli.idForceDLL,cli.OutputDir);
}

bool DoList(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	bool bSpecified=!cli.FileList.empty();
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,true);
	//t@CXgɉcȂG[bZ[W\
	if(bSpecified && cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
	//	return false;
	}

//==========
// {Jn
//==========
	CFileListFrame ListWindow(ConfigManager);
	ListWindow.CreateEx();
	ListWindow.ShowWindow(SW_SHOW);
	ListWindow.UpdateWindow();
	//ListWindow.AddArchiveFile(*cli.FileList.begin());
	if(!cli.FileList.empty()){
		bool bAllFailed=true;
		std::list<CString>::iterator ite=cli.FileList.begin();
		const std::list<CString>::iterator End=cli.FileList.end();
		for(;ite!=cli.FileList.end();++ite){
			HRESULT hr=ListWindow.OpenArchiveFile(*ite,cli.idForceDLL);
			if(SUCCEEDED(hr)){
				if(hr!=S_FALSE)bAllFailed=false;
			}else if(hr==E_ABORT){
				break;
			}
		}
		if(bAllFailed)ListWindow.DestroyWindow();
	}

	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->Run();
	TRACE(_T("Loop End\n"));
	return true;
}

//A[JCũeXg
bool DoTest(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	//SẴt@CΏۂɂ
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,false);
	//t@CXgɉcȂG[bZ[W\
	if(cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}

	//eXg
	return TestArchive(cli.FileList);
}

//R}hC߂t@C̏@肷
PROCESS_MODE ParseCommandLine(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	std::vector<CString> ParamsArray;
	int nArgc=UtilGetCommandLineParams(ParamsArray);
#if defined(_DEBUG)
	//For Debug
//	MessageBox(NULL,GetCommandLine(),_T("CommandLine"),MB_OK|MB_ICONINFORMATION);
	TRACE(_T("---Command Parameter Dump---\n"));
	for(int i=0;i<nArgc;i++)
	{
		TRACE(_T("ParamsArray[%d]=%s\n"),i,ParamsArray[i]);
	}
	TRACE(_T("---End Dump---\n\n"));
#endif

/*	if(nArgc<2){
		//s
		return PROCESS_CONFIGURE;
	}
	else if(2==nArgc&&0==_tcsncmp(_T("/"),ParamsArray[1],1)){	//IvVĂȂ
		return PROCESS_CONFIGURE;	//ݒʕ\
	}
*/
	const bool bPressedShift=GetKeyState(VK_SHIFT)<0;	//SHIFTĂ邩ǂ
	const bool bPressedControl=GetKeyState(VK_CONTROL)<0;	//CONTROLĂ邩ǂ
	PROCESS_MODE ProcessMode=PROCESS_AUTOMATIC;

	UTIL_CODEPAGE uCodePage=UTILCP_SJIS;	//X|Xt@C̃R[hy[Ww

	for(int iIndex=1;iIndex<nArgc;iIndex++){
		if(0!=_tcsncmp(_T("/"),ParamsArray[iIndex],1)){//IvVł͂Ȃ
			//t@CƂ݂ȂAΏۃt@C̃Xgɋlߍ
			//ȉ̓t@C̏
			if(0>=_tcslen(ParamsArray[iIndex])){	//NULLȂ疳
				continue;
			}
			cli.FileList.push_back(ParamsArray[iIndex]);
		}else{
			//------------------
			// IvV̉
			//------------------
			CString Parameter(ParamsArray[iIndex]);
			//ɕϊ
			Parameter.MakeLower();
			if(0==_tcsncmp(_T("/cfg"),Parameter,4)){//ݒt@Cw
				if(0==_tcsncmp(_T("/cfg:"),Parameter,5)){
					//o̓t@C̐؂o;̎_""͊OĂ
					cli.ConfigPath=(LPCTSTR)Parameter+5;
				}else if(_T("/cfg")==Parameter){
					cli.ConfigPath.Empty();
				}else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				//ݒt@C̎w肪L΃Zbg;΃ftHgɖ߂
				if(cli.ConfigPath.IsEmpty()){
					ConfigManager.SetConfigFile(NULL);
				}else{
					ConfigManager.SetConfigFile(cli.ConfigPath);
				}
				TRACE(_T("ConfigPath=%s\n"),cli.ConfigPath);
			}else if(0==_tcsncmp(_T("/cp"),Parameter,3)){//X|Xt@C̃R[hy[Ww
				if(0==_tcsncmp(_T("/cp:"),Parameter,4)){
					CString cp((LPCTSTR)Parameter+4);
					cp.MakeLower();
					if(cp==_T("utf8")||cp==_T("utf-8")){
						uCodePage=UTILCP_UTF8;
					}else if(cp==_T("utf16")||cp==_T("utf-16")||cp==_T("unicode")){
						uCodePage=UTILCP_UTF16;
					}else if(cp==_T("sjis")||cp==_T("shiftjis")||cp==_T("s-jis")||cp==_T("s_jis")){
						uCodePage=UTILCP_SJIS;
					}else{
						CString msg;
						msg.Format(IDS_ERROR_INVALID_PARAMETER,(LPCTSTR)ParamsArray[iIndex]+4);
						ErrorMessage(msg);
						return PROCESS_INVALID;
					}
				}else if(_T("/cp")==Parameter){
					uCodePage=UTILCP_SJIS;	//ftHgɖ߂
				}else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
			}else if(0==_tcsncmp(_T("/c"),Parameter,2)){//kwĂ
				ProcessMode=PROCESS_COMPRESS;
				//----------------
				// k`̉
				//----------------
				if(_T("/c")==Parameter){	//`w肳ĂȂꍇ
					cli.CompressType=PARAMETER_UNDEFINED;
				}else if(0!=_tcsncmp(_T("/c:"),Parameter,3)){
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}else if(DLL_ID_B2E==cli.idForceDLL){	//B2Eňkꍇ
					//k̂ݐ؂肾
					cli.strFormat=(LPCTSTR)Parameter+3;
				}else{
					cli.CompressType=PARAMETER_UNDEFINED;
					//R}hCp[^ƌ`̑Ή\T
					for(int i=0;i<COMPRESS_PARAM_COUNT;i++){
						if(CompressParameterArray[i].Param==Parameter){
							cli.CompressType=CompressParameterArray[i].Type;
							cli.Options=CompressParameterArray[i].Options;
							break;
						}
					}
					if(PARAMETER_UNDEFINED==cli.CompressType){
						CString msg;
						msg.Format(IDS_ERROR_INVALID_COMPRESS_PARAMETER,Parameter);
						ErrorMessage(msg);
						return PROCESS_INVALID;
					}

					//CONTROLL[ĂȂAʈk
					if(bPressedControl){
						cli.bSingleCompression=true;
					}
				}
			}else if(_T("/e")==Parameter){//𓀂wĂ
				if(bPressedShift){
					ProcessMode=PROCESS_LIST;	//SHIFTL[Ă{[h
				}else if(bPressedControl){
					ProcessMode=PROCESS_TEST;	//CTRLL[Ă猟[h
				}else{
					ProcessMode=PROCESS_EXTRACT;
				}
			}else if(_T("/l")==Parameter){//t@Cꗗ\
				ProcessMode=PROCESS_LIST;
			}else if(_T("/t")==Parameter){//A[JCueXg
				ProcessMode=PROCESS_TEST;
			}else if(_T("/m")==Parameter){//@I
				CConfigOpenAction ConfOpenAction;
				ConfOpenAction.load(ConfigManager);
				OPENACTION OpenAction;
				if(bPressedShift){	//---Shift
					OpenAction=ConfOpenAction.OpenAction_Shift;
				}else if(bPressedControl){	//---Ctrl
					OpenAction=ConfOpenAction.OpenAction_Ctrl;
				}else{	//---ʏ펞
					OpenAction=ConfOpenAction.OpenAction;
				}
				switch(OpenAction){
				case OPENACTION_EXTRACT://
					ProcessMode=PROCESS_EXTRACT;
					break;
				case OPENACTION_LIST:	//{
					ProcessMode=PROCESS_LIST;
					break;
				case OPENACTION_TEST:	//
					ProcessMode=PROCESS_TEST;
					break;
				case OPENACTION_ASK:	//mF
					ProcessMode=SelectOpenAction();
					if(ProcessMode==PROCESS_INVALID){
						return PROCESS_INVALID;
					}
					break;
				default:
					ASSERT(!"This code must not be run");
					return PROCESS_INVALID;
				}
			}else if(_T("/!")==Parameter||_T("/xacrett")==Parameter){//XacRett.DLLgp
				cli.idForceDLL=DLL_ID_XACRETT;
			}else if(_T("/b2e")==Parameter){//B2E32.dllgp
				cli.idForceDLL=DLL_ID_B2E;
			}else if(_T("/b2esfx")==Parameter){//B2E32.dllgpĎȉ𓀂Ɉk
				cli.Options|=COMPRESS_SFX;
			}else if(_T("/s")==Parameter){//t@Ck
				cli.bSingleCompression=true;
			}else if(0==_tcsncmp(_T("/o"),Parameter,2)){//o͐tH_w
				if(0==_tcsncmp(_T("/o:"),Parameter,3)){
					//o͐tH_̐؂o;̎_""͊OĂ
					cli.OutputDir=(LPCTSTR)Parameter+3;
				}else if(_T("/o")==Parameter){
					cli.OutputDir.Empty();
				}else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				TRACE(_T("OutputDir=%s\n"),cli.OutputDir);
			}else if(0==_tcsncmp(_T("/@"),Parameter,2)&&Parameter.GetLength()>2){//X|Xt@Cw
				CString strFile;
				if(PATHERROR_NONE!=UtilGetCompletePathName(strFile,(LPCTSTR)Parameter+2)||
					!UtilReadFromResponceFile(strFile,uCodePage,cli.FileList)){
					//ǂݍݎs
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_READ_RESPONCEFILE)));
					return PROCESS_INVALID;
				}
			}else if(0==_tcsncmp(_T("/$"),Parameter,2)&&Parameter.GetLength()>2){//X|Xt@Cw(ǂݎ폜)
				CString strFile;
				if(PATHERROR_NONE!=UtilGetCompletePathName(strFile,(LPCTSTR)Parameter+2)||
					!UtilReadFromResponceFile(strFile,uCodePage,cli.FileList)){
					//ǂݍݎs
					ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_READ_RESPONCEFILE)));
					return PROCESS_INVALID;
				}
				else DeleteFile(strFile);	//폜
			}else if(0==_tcsncmp(_T("/f"),Parameter,2)){//o̓t@Cw
				if(0==_tcsncmp(_T("/f:"),Parameter,3)){
					//o̓t@C̐؂o;̎_""͊OĂ
					cli.OutputFileName=(LPCTSTR)Parameter+3;
				}else if(_T("/f")==Parameter){
					cli.OutputFileName.Empty();
				}else{
					CString msg;
					msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
					ErrorMessage(msg);
					return PROCESS_INVALID;
				}
				TRACE(_T("OutputFileName=%s\n"),cli.OutputFileName);
			}else if(0==_tcsncmp(_T("/method:"),Parameter,8)){//k\bhw
				cli.strMethod=(LPCTSTR)Parameter+8;
			}else if(0==_tcsncmp(_T("/level:"),Parameter,7)){//k\bhw
				cli.strLevel=(LPCTSTR)Parameter+7;
			}else{	//m̃IvV
				CString msg;
				msg.Format(IDS_ERROR_INVALID_PARAMETER,ParamsArray[iIndex]);
				ErrorMessage(msg);
				return PROCESS_INVALID;
			}
		}
	}
	if(cli.FileList.empty()){
		//XCb`݂̂w肳Ăꍇɂ͐ݒʂ\
		//------
		// ݂Ȃt@Cw肳Ăꍇɂ̓G[ԂĂ̂ŁA
		// Ńt@CXgł΃t@Cw肳ĂȂƔfłB
		//return PROCESS_CONFIGURE;
	}else{
		//ChJ[h̓WJ
		UtilPathExpandWild(cli.FileList,cli.FileList);
	}
	//---t@C̃tpXȂǃ`FbN
	for(std::list<CString>::iterator ite=cli.FileList.begin();ite!=cli.FileList.end();ite++){
		CPath strAbsPath;
		switch(UtilGetCompletePathName(strAbsPath,*ite)){
		case PATHERROR_NONE:
			//
			break;
		case PATHERROR_INVALID:
			//p[^w肪s
			ASSERT(!"p[^w肪s");
			return PROCESS_INVALID;
		case PATHERROR_ABSPATH:
			//΃pX̎擾Ɏs
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_ABSPATH)));
			return PROCESS_INVALID;
		case PATHERROR_NOTFOUND:
			//t@C̓tH_݂Ȃ
			{
				CString msg;
				msg.Format(IDS_ERROR_FILE_NOT_FOUND,*ite);
				ErrorMessage(msg);
			}
			return PROCESS_INVALID;
		case PATHERROR_LONGNAME:
			//Ot@C擾s
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_LONGNAME)));
			return PROCESS_INVALID;
		}

		//pX̍Ōオ\ŏIĂ\菜
		strAbsPath.RemoveBackslash();
		TRACE(strAbsPath),TRACE(_T("\n"));

		//lXV
		*ite=(CString)strAbsPath;
	}
	//o̓tH_w肳ĂA΃pXɕϊ
	if(!cli.OutputDir.IsEmpty()){
		if(!UtilGetAbsPathName(cli.OutputDir,cli.OutputDir)){
			//΃pX̎擾Ɏs
			ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FAIL_GET_ABSPATH)));
			return PROCESS_INVALID;
		}
	}

	return ProcessMode;
}


//JI
PROCESS_MODE SelectOpenAction()
{
	COpenActionDialog Dialog;
	switch(Dialog.DoModal()){
	case IDC_BUTTON_OPENACTION_EXTRACT:
		return PROCESS_EXTRACT;
	case IDC_BUTTON_OPENACTION_LIST:
		return PROCESS_LIST;
	case IDC_BUTTON_OPENACTION_TEST:
		return PROCESS_TEST;
	default:
		return PROCESS_INVALID;
	}
}


//XgtH_폜ATutH_̃t@Cǉ
void MakeListFilesOnly(std::list<CString> &FileList,DLL_ID idForceDLL,LPCTSTR lpDenyExt,bool bArchivesOnly)
{
	std::list<CString>::iterator ite;
	for(ite=FileList.begin();ite!=FileList.end();){
		if(PathIsDirectory(*ite)){
			//---𓀑ΏۂtH_ȂċA𓀂
			std::list<CString> subFileList;
			UtilRecursiveEnumFile(*ite,subFileList);

			for(std::list<CString>::iterator ite2=subFileList.begin();ite2!=subFileList.end();ite2++){
				if(!bArchivesOnly||CArchiverDLLManager::GetInstance().GetArchiver(*ite2,lpDenyExt,idForceDLL)){
					//ΉĂ`̂ݒǉKv鎞́A𓀉\Ȍ`ǂ肷
					FileList.push_back(*ite2);
				}
			}
			//͍폜
			ite=FileList.erase(ite);
		}
		else{
			ite++;
		}
	}
}
